<?
	include_once "IPSLogger.ips.php";
	include_once "IPSShadowing_Configuration.ips.php";
	include_once "IPSShadowing_Logging.ips.php";

	// ----------------------------------------------------------------------------------------------------------------------------
	function IPSShadowing_SetStatus($DeviceId) {
	   if (GetValue(get_ControlId(c_Control_StepsToDo, $DeviceId))<>"") {
	      return;
	   }
	
   	$Position   = GetValue(get_ControlId(c_Control_Position, $DeviceId));
   	$MovementId = GetValue(get_ControlId(c_Control_Movement, $DeviceId));
	   if (!GetValue(get_ControlId(c_Control_Automatic, $DeviceId))) {
	      if ($MovementId<=c_MovementId_Opened and $MovementId>=c_MovementId_Closed) {
		   	$Status = 'Manuell';
	   	} elseif ($Position<=10) {
		   	$Status = 'Manuell';
	   	} else {
		   	$Status = "Manuell / $Position%";
	   	}
	   } elseif (GetValue(get_ControlId(c_Control_ManualChange, $DeviceId))) {
	      if ($MovementId<=c_MovementId_Opened and $MovementId>=c_MovementId_Closed) {
		   	$Status = 'Autom./Manuell';
	   	} elseif ($Position<=10) {
		   	$Status = 'Autom./Manuell';
	   	} else {
				$Status = "Autom./Manuell $Position%";
			}
		} else {
			$Status = 'Automatik';
		}
		SetValue(get_ControlId(c_Control_Display, $DeviceId), $Status);
	}

	// ----------------------------------------------------------------------------------------------------------------------------
   function IPSShadowing_SetValue($ControlId, $Value) {
	   $DeviceId = get_DeviceIdByControlId($ControlId);
	   if (GetValue($ControlId)<>$Value) {
	      if (GetValue(get_ControlId(c_Control_ManualChange, $DeviceId))) {
	         SetValue(get_ControlId(c_Control_ManualChange, $DeviceId), false);
	      }
			SetValue($ControlId, $Value);
			IPSShadowing_LogChange($DeviceId, $Value, $ControlId);
			IPSShadowing_SetStatus($DeviceId);
	   }
   }

	// ----------------------------------------------------------------------------------------------------------------------------
   function IPSShadowing_SetAutomatic($ControlId, $Value) {
	   if (GetValue($ControlId)<>$Value) {
			SetValue($ControlId, $Value);
		   $DeviceId = get_DeviceIdByControlId($ControlId);
	      if (GetValue(get_ControlId(c_Control_ManualChange, $DeviceId))) {
	         SetValue(get_ControlId(c_Control_ManualChange, $DeviceId), false);
	      }
	      if (GetValue(get_ControlId(c_Control_TempChange, $DeviceId))) {
	         SetValue(get_ControlId(c_Control_TempChange, $DeviceId), false);
	      }
			IPSShadowing_LogChange($DeviceId, $Value, $ControlId);
			IPSShadowing_SetStatus($DeviceId);
		}
   }

	// ----------------------------------------------------------------------------------------------------------------------------
   function IPSShadowing_SetTime($ControlId, $ModeId) {
		$ControlType = get_ControlType($ControlId);
		if ($ControlType==c_Control_BeginOfDayTime and $ModeId==c_ModeId_Twillight and c_Setting_TwilightBODPath<>"") {
		   SetValue($ControlId, GetValue(get_IdByPath(c_Setting_TwilightBODPath)));
 			IPS_SetVariableCustomAction($ControlId, null);
		} elseif ($ControlType==c_Control_BeginOfDayTime and $ModeId==c_ModeId_LimitedTwillight and c_Setting_TwilightLimitedBODPath<>"") {
		   SetValue($ControlId, GetValue(get_IdByPath(c_Setting_TwilightLimitedBODPath)));
 			IPS_SetVariableCustomAction($ControlId, null);
		} elseif ($ControlType==c_Control_EndOfDayTime and $ModeId==c_ModeId_Twillight and c_Setting_TwilightEODPath<>"") {
		   SetValue($ControlId, GetValue(get_IdByPath(c_Setting_TwilightEODPath)));
 			IPS_SetVariableCustomAction($ControlId, null);
		} elseif ($ControlType==c_Control_EndOfDayTime and $ModeId==c_ModeId_LimitedTwillight and c_Setting_TwilightLimitedEODPath<>"") {
		   SetValue($ControlId, GetValue(get_IdByPath(c_Setting_TwilightLimitedEODPath)));
 			IPS_SetVariableCustomAction($ControlId, null);

		} elseif ($ModeId==c_ModeId_Individual) {
 			IPS_SetVariableCustomAction($ControlId, c_ID_ChangeSettingsScript);

		} else {
 			IPS_SetVariableCustomAction($ControlId, c_ID_ChangeSettingsScript);
		   return false;
		}
		return true;
   }

	// ----------------------------------------------------------------------------------------------------------------------------
   function IPSShadowing_SetMode($ControlId, $Value) {
	   $DeviceId    = get_DeviceIdByControlId($ControlId);
		$ControlType = get_ControlType($ControlId);
	   $DeviceId    = get_DeviceIdByControlId($ControlId);

		if ($ControlType==c_Control_BeginOfDayMode) {
		   $TimeControlId = get_ControlId(c_Control_BeginOfDayTime, $DeviceId);
		} else {
		   $TimeControlId = get_ControlId(c_Control_EndOfDayTime, $DeviceId);
		}

	   if (GetValue($ControlId)<>$Value) {
			if (!IPSShadowing_SetTime($TimeControlId, $Value)) {
			   return;
			}
			SetValue($ControlId, $Value);
			IPSShadowing_LogChange($DeviceId, $Value, $ControlId);
	   }
   }

	// ----------------------------------------------------------------------------------------------------------------------------
	function get_DeviceNameByDeviceId($DeviceId) {
	   $DeviceName = IPS_GetName($DeviceId);
		return $DeviceName;
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function get_DeviceIdByDeviceName($DeviceName, $ParentId=c_ID_Shadowing) {
	   $DeviceId = IPS_GetCategoryIDByName($DeviceName, $ParentId);
		return $DeviceId;
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function get_DeviceIdByControlId($ControlId) {
	   $DeviceId = IPS_GetParent($ControlId);
	   if ($DeviceId === false) {
	      IPSLogger_Err(__file__, "DeviceId could NOT be found for ControlId=$ControlId");
	      exit;
	   }

		return $DeviceId;
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function get_ControlType($ControlId) {
	   $ControlName = IPS_GetName($ControlId);
	   return $ControlName;
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function get_ControlId($ControlName, $DeviceId) {
	   $VariableId = IPS_GetVariableIDByName($ControlName, $DeviceId);
	   if ($VariableId === false) {
	      IPSLogger_Err(__file__, "Control '$ControlName' could NOT be found for DeviceId=$DeviceId");
	      exit;
	   }

	   return $VariableId;
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function get_SettingControlId($ControlName) {
	   $VariableId = IPS_GetVariableIDByName($ControlName, c_ID_Settings);
	   if ($VariableId === false) {
	      IPSLogger_Err(__file__, "Control '$ControlName' could NOT be found in Settings");
	      exit;
	   }

	   return $VariableId;
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function get_ProgramName($ProgramId) {
		$ProgramList = array(
			c_ProgramId_Manual      			=> c_Program_Manual,
			c_ProgramId_Opened      			=> c_Program_Opened,
			c_ProgramId_OpenedOrShadowing		=> c_Program_OpenedOrShadowing,
			c_ProgramId_OpenedAndShadowing	=> c_Program_OpenedAndShadowing,
			c_ProgramId_OpenedDay				=> c_Program_OpenedDay,
			c_ProgramId_OpenedNight    		=> c_Program_OpenedNight,
			c_ProgramId_Closed      			=> c_Program_Closed,
			c_ProgramId_Dimout      			=> c_Program_Dimout,
			c_ProgramId_DimoutOrShadowing		=> c_Program_DimoutOrShadowing,
			c_ProgramId_DimoutAndShadowing	=> c_Program_DimoutAndShadowing
		);

		return $ProgramList[$ProgramId];
	}

   // ----------------------------------------------------------------------------------------------------------------------------
   function get_IdByPath($Path) {
      if ($Path=="") {
         return false;
      }
      $CategoryList = explode('.',$Path);
      $ObjId = 0;
      foreach ($CategoryList as $Idx=>$Category) {
        $ObjId = IPS_GetObjectIDByName($Category, $ObjId);
        if ($ObjId==null) {
            IPSLogger_Err(__file__, "Category '$Category' could NOT be found in Path '$Path'");
            exit;
		  };
      }
      return $ObjId;
	}



?>