<?
	// ----------------------------------------------------------------------------------------------------------------------------
	//
	// Function will be called when DeviceType in Configuration File is set to c_DeviceType_Custom
	//
	// Parameters:
	//   $DeviceId   - ID of current Shadowing Device (means Program.IPSShadowing.Devices.MyCurrentDevice)
	//   $DevicePath - Configuration Value c_Property_DevicePath for current Device
	//   $Command    - Current Command, possible Values: c_MovementId_Up, c_MovementId_Down and c_MovementId_Stop
	//
	// ----------------------------------------------------------------------------------------------------------------------------

	function IPSShadowing_MoveByHardwareCustom($DeviceId, $DevicePath, $Command) {
      $DeviceName   = get_DeviceNameByDeviceId($DeviceId);

	}

	// ----------------------------------------------------------------------------------------------------------------------------
	//
	// Function will be called by the Program Timer when no manual Invervention has occured, present
	// is not activated and Automatic is enabled.
	// Shadowing can be activated as described below, to prevent other Programs from being executed,
	// the function has to return true;
	//
	// Parameters:
	//   $DeviceId   - ID of current Shadowing Device (means Program.IPSShadowing.Devices.MyCurrentDevice)
	//   $isDay      - boolean Value, indicating Day or Night
	//
	// Executing a Program:
   //   IPSShadowing_MoveByProgram($DeviceId, c_ProgramId_Opened);    // Opening
   //   IPSShadowing_MoveByProgram($DeviceId, c_ProgramId_Closed);    // Close a Shutter
   //   IPSShadowing_MoveByProgram($DeviceId, c_ProgramId_Dimout);    // Close a Jalousie
   //   IPSShadowing_MoveByProgram($DeviceId, c_ProgramId_Shadowing); // Shadowing a Jalousie
	//
	// ----------------------------------------------------------------------------------------------------------------------------

	function IPSShadowing_ProgramCustom($DeviceId, $isDay) {
      $DeviceName   = get_DeviceNameByDeviceId($DeviceId);

	   return false;
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	//
	// Moving a Device by a other Script (like a Script for a Shutter Switch) can be done by calling then
	// Function IPSShadowing_MoveByControl
	//
	// Parameters:
	//   $DeviceId   - ID of MovementControl of Shadowing Device (means Program.IPSShadowing.Devices.MyCurrentDevice.Movement)
	//   $Command    - Command: c_MovementId_Up, c_MovementId_Down and c_MovementId_Stop
	//
	// ----------------------------------------------------------------------------------------------------------------------------

	//include_once "IPSShadowing_Movement.ips.php";
	//IPSShadowing_MoveByControl($ControlID, c_MovementId_Down);
	//IPSShadowing_MoveByControl($ControlID, c_MovementId_Up);
	//IPSShadowing_MoveByControl($ControlID, c_MovementId_Stop);

?>