<?
	// ----------------------------------------------------------------------------------------------------------------------------
	function get_InstanceIDByDevicePath($Path) {
		$ObjId = false;
		foreach (explode('.',$Path) as $Idx=>$Category) {
		   $ObjId = @IPS_GetObjectIDByName($Category, $ObjId);
		   if ($ObjId===false) {
			   if (@IPS_InstanceExists((int)$Path)) {
			      return (int)$Path;
				}
				return false;
			}
		}
		
		return $ObjId;
	}


	// ----------------------------------------------------------------------------------------------------------------------------
   function IPSShadowing_MoveByHardwareShutterModule($DeviceId, $DevicePath, $Command) {
	   $InstanceId = get_InstanceIDByDevicePath($DevicePath);
  		if ($InstanceId===false) {
     		IPSLogger_Wrn(__file__, "Device $DevicePath could NOT be found to activate Shadowing for a 'ShutterModule' Device");
  		} elseif ($Command==c_MovementId_Up) {
     		IPSLogger_Dbg(__file__, "Move Up of Shadowing Device $DevicePath: call SC_MoveUp($InstanceId,0)");
			SC_MoveUp($InstanceId,0);
  		} elseif ($Command==c_MovementId_Down) {
     		IPSLogger_Dbg(__file__, "Move Down of Shadowing Device $DevicePath: call SC_MoveDown($InstanceId,0)");
			SC_MoveDown($InstanceId,0);
		} else {
     		IPSLogger_Dbg(__file__, "Stop of Shadowing Device $DevicePath: call SC_Stop($InstanceId)");
			SC_Stop($InstanceId);
		}
	}

	// ----------------------------------------------------------------------------------------------------------------------------
   function IPSShadowing_MoveByHardwareMoellerEaton($DeviceId, $DevicePath, $Command) {
	   $InstanceId = get_InstanceIDByDevicePath($DevicePath);
  		if ($InstanceId===false) {
     		IPSLogger_Wrn(__file__, "Device $DevicePath could NOT be found to activate Shadowing for a 'MoellerEaton' Device");
  		} elseif ($Command==c_MovementId_Up) {
     		IPSLogger_Dbg(__file__, "Move Up of Shadowing Device $DevicePath: call MXC_ShutterMoveUp($InstanceId)");
			MXC_ShutterMoveUp($InstanceId);
  		} elseif ($Command==c_MovementId_Down) {
     		IPSLogger_Dbg(__file__, "Move Down of Shadowing Device $DevicePath: call MXC_ShutterMoveDown($InstanceId)");
			MXC_ShutterMoveDown($InstanceId);
		} else {
     		IPSLogger_Dbg(__file__, "Stop of Shadowing Device $DevicePath: call MXC_ShutterStop($DeviceId)");
			MXC_ShutterStop($InstanceId);
		}
	}

	// ----------------------------------------------------------------------------------------------------------------------------
   function IPSShadowing_MoveByHardwareHomematic($DeviceId, $DevicePath, $Command) {
	   $InstanceId = get_InstanceIDByDevicePath($DevicePath);
  		if ($InstanceId===false) {
     		IPSLogger_Wrn(__file__, "Device $DevicePath could NOT be found to activate Shadowing for a 'Homematic' Device");
  		} elseif ($Command==c_MovementId_Up) {
     		IPSLogger_Dbg(__file__, "Move Up of Shadowing Device $DevicePath: call HM_WriteValueFloat($InstanceId , 'LEVEL', 1)");
			HM_WriteValueFloat($InstanceId , 'LEVEL', 1);
  		} elseif ($Command==c_MovementId_Down) {
     		IPSLogger_Dbg(__file__, "Move Down of Shadowing Device $DevicePath: call HM_WriteValueFloat($InstanceId , 'LEVEL', 0)");
			HM_WriteValueFloat($InstanceId , 'LEVEL', 0);
		} else {
     		IPSLogger_Dbg(__file__, "Stop of Shadowing Device $DevicePath: call HM_WriteValueBoolean($InstanceId , 'STOP', true)");
			HM_WriteValueBoolean($InstanceId , 'STOP', true);
		}
	}

	// ----------------------------------------------------------------------------------------------------------------------------
   function IPSShadowing_MoveByHardwareEnocean($DeviceId, $DevicePath, $Command) {
      $MovementId = GetValue(get_ControlId(c_Control_Movement, $DeviceId));
	   $InstanceId = get_InstanceIDByDevicePath($DevicePath);
  		if ($InstanceId===false) {
     		IPSLogger_Wrn(__file__, "Device $DevicePath could NOT be found to activate Shadowing for a 'Enocean' Device");
  		} elseif ($Command==c_MovementId_Up) {
  		   if ($MovementId<>c_MovementId_Up and $MovementId<>c_MovementId_Down) {
	     		IPSLogger_Dbg(__file__, "Move Up of Shadowing Device $DevicePath: call ENO_SwitchMode($InstanceId, true)");
				ENO_SwitchMode($InstanceId, true);
			}
  		} elseif ($Command==c_MovementId_Down) {
  		   if ($MovementId<>c_MovementId_Up and $MovementId<>c_MovementId_Down) {
	     		IPSLogger_Dbg(__file__, "Move Down of Shadowing Device $DevicePath: call ENO_SwitchMode($InstanceId, false)");
				ENO_SwitchMode($InstanceId, false);
			}
		} else {
  		   if ($MovementId==c_MovementId_Up) {
	     		IPSLogger_Dbg(__file__, "Stop of Shadowing Device $DevicePath: call ENO_SwitchMode($InstanceId, true)");
				ENO_SwitchMode($InstanceId, true);
  		   } elseif ($MovementId==c_MovementId_Down) {
	     		IPSLogger_Dbg(__file__, "Stop of Shadowing Device $DevicePath: call ENO_SwitchMode($InstanceId, false)");
				ENO_SwitchMode($InstanceId, false);
			} else {
			}
		}
	}

	// ----------------------------------------------------------------------------------------------------------------------------
   function IPSShadowing_MoveByHardware1Wire($DeviceId, $DevicePath, $Command) {
	   $InstanceId = get_InstanceIDByDevicePath($DevicePath);
  		if ($InstanceId===false) {
     		IPSLogger_Wrn(__file__, "Device $DevicePath could NOT be found to activate Shadowing for a '1Wire' Device");
  		} elseif ($Command==c_MovementId_Up) {
     		IPSLogger_Dbg(__file__, "Move Up of Shadowing Device $DevicePath: call @TMEX_F29_SetStrobe($InstanceId, True); @TMEX_F29_SetPort((integer)$InstanceId, (integer)120+128);");
   		@TMEX_F29_SetStrobe($InstanceId, True);
   		@TMEX_F29_SetPort((integer)$InstanceId, (integer)120+128);
  		} elseif ($Command==c_MovementId_Down) {
     		IPSLogger_Dbg(__file__, "Move Down of Shadowing Device $DevicePath: call @TMEX_F29_SetStrobe($InstanceId, True); @TMEX_F29_SetPort((integer)$InstanceId, (integer)120);");
   		@TMEX_F29_SetStrobe($InstanceId, True);
   		@TMEX_F29_SetPort((integer)$InstanceId, (integer)120);
		} else {
     		IPSLogger_Dbg(__file__, "Stop of Shadowing Device $DevicePath: call @TMEX_F29_SetStrobe($InstanceId, True); @TMEX_F29_SetPort((integer)$InstanceId, (integer)0);");
   		@TMEX_F29_SetStrobe($InstanceId, True);
   		@TMEX_F29_SetPort((integer)$InstanceId, (integer)0);
		}
	}

	// ----------------------------------------------------------------------------------------------------------------------------
   function IPSShadowing_MoveByHardwareLCN($DeviceId, $DevicePath, $Command) {
      $DeviceName   = get_DeviceNameByDeviceId($DeviceId);
      $DeviceConfig = get_ShadowingConfiguration();
		$DevicePath2  = $DeviceConfig[$DeviceName][c_Property_DevicePath2];
	   $InstanceId1  = get_InstanceIDByDevicePath($DevicePath);
	   $InstanceId2  = get_InstanceIDByDevicePath($DevicePath2);

  		if ($InstanceId1===false or $InstanceId2===false) {
     		IPSLogger_Wrn(__file__, "Devices $DevicePath, $DevicePath2 could NOT be found to activate Shadowing for a 'LCN' Device");
     		return;
		}
		
      $type=LCN_GetUnit($InstanceId1);
      switch($type) {
         case 0:
		  		if ($Command==c_MovementId_Up) {
		     		IPSLogger_Dbg(__file__, "Move Up of Shadowing Device $DevicePath: call LCN_SetIntensity($InstanceId1,100,4);");
         		LCN_SetIntensity($InstanceId1,100,4);
		  		} elseif ($Command==c_MovementId_Down) {
		     		IPSLogger_Dbg(__file__, "Move Down of Shadowing Device $DevicePath: call LCN_SetIntensity($InstanceId2,100,4);");
         		LCN_SetIntensity($InstanceId2,100,4);
				} else {
		     		IPSLogger_Dbg(__file__, "Stop of Shadowing Device $DevicePath: call LCN_SetIntensity($InstanceId1,0,0); LCN_SetIntensity($InstanceId2,0,0);");
		      	LCN_SetIntensity($InstanceId1,0,0);
		         LCN_SetIntensity($InstanceId2,0,0);
				}
				break;

         case 2:
		  		if ($Command==c_MovementId_Up) {
		     		IPSLogger_Dbg(__file__, "Move Up of Shadowing Device $DevicePath: call LCN_SetIntensity($InstanceId1,100,4);");
					LCN_SwitchRelay($InstanceId1, true);
					LCN_SwitchRelay($InstanceId2, false); // Um Relaisrichtung zu ndern bitte auf true
 		  		} elseif ($Command==c_MovementId_Down) {
		     		IPSLogger_Dbg(__file__, "Move Down of Shadowing Device $DevicePath: call LCN_SetIntensity($InstanceId2,100,4);");
					LCN_SwitchRelay($InstanceId1, true);
					LCN_SwitchRelay($InstanceId2, true); // Um Relaisrichtung zu ndern bitte auf false
 				} else {
		     		IPSLogger_Dbg(__file__, "Stop of Shadowing Device $DevicePath: call LCN_SwitchRelay($InstanceId1,false;");
             	LCN_SwitchRelay($InstanceId1,false);
				}
				break;

			default:
     			IPSLogger_Err(__file__, "Unknown LCNType $type found for LCN Instance $InstanceId1");
				exit;
		}
	}

	// ----------------------------------------------------------------------------------------------------------------------------
   function IPSShadowing_MoveByHardwareFS20($DeviceId, $DevicePath, $Command) {
      $MovementId = GetValue(get_ControlId(c_Control_Movement, $DeviceId));
	   $InstanceId = get_InstanceIDByDevicePath($DevicePath);
  		if ($InstanceId===false) {
     		IPSLogger_Wrn(__file__, "Device $DevicePath could NOT be found to activate Shadowing for a 'Enocean' Device");
  		} elseif ($Command==c_MovementId_Up) {
  		   if ($MovementId<>c_MovementId_Up and $MovementId<>c_MovementId_Down) {
	     		IPSLogger_Dbg(__file__, "Move Up of Shadowing Device $DevicePath: call FS20_SwitchMode($InstanceId, true)");
				FS20_SwitchMode($InstanceId, true);
			} else {
	     		IPSLogger_Dbg(__file__, "Shadowing Device $DevicePath is already in Status '$MovementId' MoveUp/MoveDown,  !!!");
			}
  		} elseif ($Command==c_MovementId_Down) {
  		   if ($MovementId<>c_MovementId_Up and $MovementId<>c_MovementId_Down) {
	     		IPSLogger_Dbg(__file__, "Move Down of Shadowing Device $DevicePath: call FS20_SwitchMode($InstanceId, false)");
				FS20_SwitchMode($InstanceId, false);
			} else {
	     		IPSLogger_Dbg(__file__, "Shadowing Device $DevicePath is already in Status '$MovementId' MoveUp/MoveDown,  !!!");
			}
		} else {
  		   if ($MovementId==c_MovementId_Up) {
	     		IPSLogger_Dbg(__file__, "Stop of Shadowing Device $DevicePath: call FS20_SwitchMode($InstanceId, true)");
				FS20_SwitchMode($InstanceId, true);
  		   } elseif ($MovementId==c_MovementId_Down) {
	     		IPSLogger_Dbg(__file__, "Stop of Shadowing Device $DevicePath: call FS20_SwitchMode($InstanceId, false)");
				FS20_SwitchMode($InstanceId, false);
			} else {
			}
		}
	}

	// ----------------------------------------------------------------------------------------------------------------------------
   function get_DeviceTypeByInstanceId($InstanceId) {
		$DeviceInfo = IPS_GetInstance($InstanceId);
		switch($DeviceInfo['ModuleInfo']['ModuleID']) {
  			case "{48FCFDC1-11A5-4309-BB0B-A0DB8042A969}": //FS20
  			   $DeviceType = c_DeviceType_FS20;
  			   break;
			case "{1B7B5B7D-CAA9-4AB5-B9D8-EC805EC955AD}": //xComfort
  			   $DeviceType = c_DeviceType_MoellerEaton;
  			   break;
			case "{2D871359-14D8-493F-9B01-26432E3A710F}": //LCN
  			   $DeviceType = c_DeviceType_LCN;
  			   break;
			case "{9317CC5B-4E1D-4440-AF3A-5CC7FB42CCAA}": //1-Wire Shutter
  			   $DeviceType = c_DeviceType_1Wire;
  			   break;
			case "{EE4A81C6-5C90-4DB7-AD2F-F6BBD521412E}": //Homematic Shutter
  			   $DeviceType = c_DeviceType_Homematic;
  			   break;
			case "{8492CEAF-ED62-4634-8A2F-B09A7CEDDE5B}": //enocean
  			   $DeviceType = c_DeviceType_Enocean;
  			   break;
			case "{542CC907-CA63-4E7A-A8C7-92F74639FA4C}": //Shutter Module
  			   $DeviceType = c_DeviceType_ShutterModule;
  			   break;
			default:
			   IPSLogger_Err(__file__, "Automatic Activation NOT supported for ModuleID ".$DeviceInfo['ModuleInfo']['ModuleID']);
			   exit;

		}
		return $DeviceType;
	}

	// ----------------------------------------------------------------------------------------------------------------------------
   function IPSShadowing_MoveByHardware($DeviceId, $Command) {
      $DeviceName   = get_DeviceNameByDeviceId($DeviceId);
      $DeviceConfig = get_ShadowingConfiguration();
		$DeviceType   = $DeviceConfig[$DeviceName][c_Property_DeviceType];
		$DevicePath   = $DeviceConfig[$DeviceName][c_Property_DevicePath];

		if ($DeviceType==c_DeviceType_Auto) {
		   $InstanceId = get_InstanceIDByDevicePath($DevicePath);
	  		if ($InstanceId===false) {
	     		IPSLogger_Wrn(__file__, "Device $DevicePath could NOT be found to activate Shadowing");
	     		return;
			}
			$DeviceType = get_DeviceTypeByInstanceId($InstanceId);
		}

		switch($DeviceType) {
		   case c_DeviceType_Homematic:
		      IPSShadowing_MoveByHardwareHomematic($DeviceId, $DevicePath, $Command);
		      break;
		   case c_DeviceType_MoellerEaton:
		      IPSShadowing_MoveByHardwareMoellerEaton($DeviceId, $DevicePath, $Command);
		      break;
		   case c_DeviceType_LCN:
		      IPSShadowing_MoveByHardwareLCN($DeviceId, $DevicePath, $Command);
		      break;
		   case c_DeviceType_Enocean:
		      IPSShadowing_MoveByHardwareEnocean($DeviceId, $DevicePath, $Command);
		      break;
		   case c_DeviceType_FS20:
		      IPSShadowing_MoveByHardwareFS20($DeviceId, $DevicePath, $Command);
		      break;
		   case c_DeviceType_1Wire:
		      IPSShadowing_MoveByHardware1Wire($DeviceId, $DevicePath, $Command);
		      break;
		   case c_DeviceType_ShutterModule:
		      IPSShadowing_MoveByHardwareShutterModule($DeviceId, $DevicePath, $Command);
		      break;
		   case c_DeviceType_Custom:
		      IPSShadowing_MoveByHardwareCustom($DeviceId, $DevicePath, $Command);
		      break;
			default:
			   IPSLogger_Err(__file__, "Unknown DeviceType '$DeviceType' for Shadowing of Device '$DeviceName'");
			   exit;
		}
	}

?>