<?
	include_once "IPSInstaller.ips.php";
	include_once "IPSShadowing_Configuration.ips.php";
	include_once "IPSShadowing_Hardware.ips.php";

	$ProgramPath            = 'Program.IPSShadowing';

	$WebfrontPath           = 'WebFront.Beschattung';
	$WebFrontConfigId       = 57215;
	$WebFrontTabPaneOrderId = 30;
	$WebFrontTabPaneName    = '';

	$iPhonePath             = 'iPhone.Beschattung';

	//DeleteWFCItems($WebFrontConfigId, 'ShadowTP');

	// ----------------------------------------------------------------------------------------------------------------------------
	// Program Installation
	// ----------------------------------------------------------------------------------------------------------------------------
	$CategoryIdShadowing = CreateCategoryPath($ProgramPath);
	$CategoryIdScripts	= CreateCategory('Scripts', $CategoryIdShadowing, 10);
	IPS_SetHidden($CategoryIdScripts, true);

	// Add Scripts
	IPS_SetParent($IPS_SELF, $CategoryIdScripts);
   $ScriptIdConstants       = CreateScript('IPSShadowing_Constants',       'IPSShadowing_Constants.ips.php',       $CategoryIdScripts, 10);
   $ScriptIdConfiguration   = CreateScript('IPSShadowing_Configuration',   'IPSShadowing_Configuration.ips.php',   $CategoryIdScripts, 20);
   $ScriptIdControl         = CreateScript('IPSShadowing_Control',         'IPSShadowing_Control.ips.php',         $CategoryIdScripts, 30);
   $ScriptIdProgram         = CreateScript('IPSShadowing_Program',         'IPSShadowing_Program.ips.php',         $CategoryIdScripts, 40);
   $ScriptIdMovement        = CreateScript('IPSShadowing_Movement',        'IPSShadowing_Movement.ips.php',        $CategoryIdScripts, 50);
   $ScriptIdHardware        = CreateScript('IPSShadowing_Hardware',        'IPSShadowing_Hardware.ips.php',        $CategoryIdScripts, 55);
   $ScriptIdChangeSettings  = CreateScript('IPSShadowing_ChangeSettings',  'IPSShadowing_ChangeSettings.ips.php',  $CategoryIdScripts, 60);
   $ScriptIdAutomaticOn     = CreateScript('IPSShadowing_AutomaticOn',     'IPSShadowing_AutomaticOn.ips.php',     $CategoryIdScripts, 70);
   $ScriptIdAutomaticOff    = CreateScript('IPSShadowing_AutomaticOff',    'IPSShadowing_AutomaticOff.ips.php',    $CategoryIdScripts, 80);
   $ScriptIdAutomaticReset  = CreateScript('IPSShadowing_AutomaticReset',  'IPSShadowing_AutomaticReset.ips.php',  $CategoryIdScripts, 90);
   $ScriptIdOpenAll         = CreateScript('IPSShadowing_OpenAll',         'IPSShadowing_OpenAll.ips.php',         $CategoryIdScripts, 100);
   $ScriptIdCloseAll        = CreateScript('IPSShadowing_CloseAll',        'IPSShadowing_CloseAll.ips.php',        $CategoryIdScripts, 110);
   $ScriptIdLogging         = CreateScript('IPSShadowing_Logging',         'IPSShadowing_Logging.ips.php',         $CategoryIdScripts, 200);
   $ScriptIdRefreshTimer    = CreateScript('IPSShadowing_RefreshTimer',    'IPSShadowing_RefreshTimer.ips.php',    $CategoryIdScripts, 210);
   $ScriptIdProgramTimer    = CreateScript('IPSShadowing_ProgramTimer',    'IPSShadowing_ProgramTimer.ips.php',    $CategoryIdScripts, 220);
   $ScriptIdResetTimer      = CreateScript('IPSShadowing_ResetTimer',      'IPSShadowing_ResetTimer.ips.php',      $CategoryIdScripts, 230);
   $ScriptIdCustom          = CreateScript('IPSShadowing_Custom',          'IPSShadowing_Custom.ips.php',          $CategoryIdScripts, 240);

	CreateTimer_OnceADay ('Reset', $ScriptIdResetTimer, 0, 5);
	CreateTimer_CyclicBySeconds ('Refresh', $ScriptIdRefreshTimer, 1, false);
	CreateTimer_CyclicByMinutes ('Program', $ScriptIdProgramTimer, 5);

	// Create Circles and Controls
	// ----------------------------------------------------------------------------------------------------------------------------
	$IPSShadowing_ProgNigJal = array(
		c_ProgramId_Manual      	=> c_Program_Manual,
		c_ProgramId_Opened      	=> c_Program_Opened,
		c_ProgramId_Dimout      	=> c_Program_Dimout);
	$IPSShadowing_ProgDayJal = array(
		c_ProgramId_Manual      	=> c_Program_Manual,
		c_ProgramId_Opened      	=> c_Program_Opened,
		c_ProgramId_OpenedOrShadowing	=> c_Program_OpenedOrShadowing,
		c_ProgramId_Dimout      	=> c_Program_Dimout);
	$IPSShadowing_ProgTempJal = array(
		c_ProgramId_Manual      	=> c_Program_Manual,
		c_ProgramId_DimoutOrShadowing	=> c_Program_DimoutOrShadowing,
		c_ProgramId_DimoutAndShadowing	=> c_Program_DimoutAndShadowing,
		c_ProgramId_Dimout      	=> c_Program_Dimout);
	$IPSShadowing_ProgPreJal = array(
		c_ProgramId_Manual      	=> c_Program_Manual,
		c_ProgramId_Opened      	=> c_Program_Opened,
		c_ProgramId_OpenedDay		=> c_Program_OpenedDay,
		c_ProgramId_OpenedNight    => c_Program_OpenedNight);

	$IPSShadowing_ProgNigSht = array(
		c_ProgramId_Manual      	=> c_Program_Manual,
		c_ProgramId_Opened      	=> c_Program_Opened,
		c_ProgramId_Closed      	=> c_Program_Closed);
	$IPSShadowing_ProgDaySht = array(
		c_ProgramId_Manual      	=> c_Program_Manual,
		c_ProgramId_Opened      	=> c_Program_Opened,
		c_ProgramId_Closed      	=> c_Program_Closed);
	$IPSShadowing_ProgTempSht = array(
		c_ProgramId_Manual      	=> c_Program_Manual,
		c_ProgramId_Closed      	=> c_Program_Closed);
	$IPSShadowing_ProgPreSht = array(
		c_ProgramId_Manual      	=> c_Program_Manual,
		c_ProgramId_Opened      	=> c_Program_Opened,
		c_ProgramId_OpenedDay		=> c_Program_OpenedDay,
		c_ProgramId_OpenedNight    => c_Program_OpenedNight);

	$IPSShadowing_Movement = array(
		c_MovementId_Opened      	=> c_Movement_Opened,
		c_MovementId_Space      	=> c_Movement_Space,
		c_MovementId_Down      		=> c_Movement_Down,
		c_MovementId_Stop      		=> c_Movement_Stop,
		c_MovementId_Up      		=> c_Movement_Up,
	);
	$IPSShadowing_MovementJal = $IPSShadowing_Movement;
	$IPSShadowing_MovementJal[c_MovementId_Shadowing] = c_Movement_Shadowing;
	$IPSShadowing_MovementJal[c_MovementId_Dimout]    = c_Movement_Dimout;

	$IPSShadowing_MovementSht = $IPSShadowing_Movement;
	$IPSShadowing_MovementSht[c_MovementId_Closed] = c_Movement_Closed;
	$IPSShadowing_MovementSht[c_MovementId_75]     = c_Movement_75;
	$IPSShadowing_MovementSht[c_MovementId_50]     = c_Movement_50;
	$IPSShadowing_MovementSht[c_MovementId_25]     = c_Movement_25;

	$IPSShadowing_MovementCol = array(
		c_MovementId_Down      		=> 0x00FF00,
		c_MovementId_Stop      		=> -1,
		c_MovementId_Up      		=> 0x00FF00,
		c_MovementId_Space      	=> 0,
		c_MovementId_Opened      	=> 0xAAAAAA,
		c_MovementId_25    			=> 0xAAAAAA,
		c_MovementId_50    			=> 0xAAAAAA,
		c_MovementId_75    			=> 0xAAAAAA,
		c_MovementId_Shadowing    	=> 0xAAAAAA,
		c_MovementId_Dimout	    	=> 0xAAAAAA,
		c_MovementId_Closed      	=> 0xAAAAAA,
	);

	$IPSShadowing_MovementJal[c_MovementId_Shadowing] = c_Movement_Shadowing;

	CreateProfile_Associations ('IPSShadowing_ProgNigSht',  $IPSShadowing_ProgNigSht);
	CreateProfile_Associations ('IPSShadowing_ProgDaySht',  $IPSShadowing_ProgDaySht);
	CreateProfile_Associations ('IPSShadowing_ProgTempSht', $IPSShadowing_ProgTempSht);
	CreateProfile_Associations ('IPSShadowing_ProgPreSht',  $IPSShadowing_ProgPreSht);
	CreateProfile_Associations ('IPSShadowing_ProgNigJal',  $IPSShadowing_ProgNigJal);
	CreateProfile_Associations ('IPSShadowing_ProgDayJal',  $IPSShadowing_ProgDayJal);
	CreateProfile_Associations ('IPSShadowing_ProgTempJal', $IPSShadowing_ProgTempJal);
	CreateProfile_Associations ('IPSShadowing_ProgPreJal',  $IPSShadowing_ProgPreJal);
	CreateProfile_Associations ('IPSShadowing_MovementJal', $IPSShadowing_MovementJal, "", $IPSShadowing_MovementCol, true);
	CreateProfile_Associations ('IPSShadowing_MovementSht', $IPSShadowing_MovementSht, "", $IPSShadowing_MovementCol, true);
	CreateProfile_Associations ('IPSShadowing_StartOfDay',  array('individuelle Zeit', 'Dmmerung', 'Dmmerung (begrenzt)'));
	CreateProfile_Associations ('IPSShadowing_EndOfDay',    array('individuelle Zeit', 'Dmmerung', 'Dmmerung (begrenzt)'));
	CreateProfile_Associations ('IPSShadowing_TempProfile', array('Aussen >= Innen', '> 1C', '> 2C', '> 3C'));
	CreateProfile_Count  ('IPSShadowing_Step',      1, 1, 4);
	CreateProfile_Count  ('IPSShadowing_Priority',  1, 1, 10);
	CreateProfile_Count  ('IPSShadowing_TempDelta', 1, 1, 5,   null, " C",null);
	CreateProfile_Count  ('IPSShadowing_Position',  0, 1, 100, null, "%",  null);

	$CategoryIdDevices	= CreateCategory('Devices', $CategoryIdShadowing, 20);
	$DeviceConfig        = get_ShadowingConfiguration();
	$Idx                 = 10;
	foreach ($DeviceConfig as $DeviceName=>$DeviceData) {
		$ShadowingType = $DeviceConfig[$DeviceName][c_Property_ShadowingType];
		$DeviceId      = CreateCategory($DeviceName, $CategoryIdDevices, $Idx);

		$ControlIdDisplay          = CreateVariable(c_Control_Display,        3 /*String*/,  $DeviceId,  50, '~String',                  null,                    'Manuell', 'Information');
		$ControlIdStepsToDo        = CreateVariable(c_Control_StepsToDo,      3 /*String*/,  $DeviceId,  60, '~String',                  null,                    '');
		$ControlIdStep             = CreateVariable(c_Control_Step,           1 /*Integer*/, $DeviceId,  70, 'IPSShadowing_Step',        null,                    -1);
		$ControlIdStartTime        = CreateVariable(c_Control_StartTime,      1 /*Integer*/, $DeviceId,  80, '~UnixTimestamp',           null,                    -1);
		$ControlIdPosition         = CreateVariable(c_Control_Position,       1 /*Integer*/, $DeviceId,  90, 'IPSShadowing_Position',    null,                    0,       'Intensity');
		$ControlIdManualChange     = CreateVariable(c_Control_ManualChange,   0 /*Boolean*/, $DeviceId, 110, '~Switch',                  $ScriptIdChangeSettings, false,   'Warning');
		$ControlIdTempChange       = CreateVariable(c_Control_TempChange,     0 /*Boolean*/, $DeviceId, 120, '~Switch',                  null                   , false,   'Warning');
		$ControlIdAutomatic        = CreateVariable(c_Control_Automatic ,     0 /*Boolean*/, $DeviceId, 130, '~Switch',                  $ScriptIdChangeSettings, false,   'Power');
		$ControlIdBeginOfDayMode   = CreateVariable(c_Control_BeginOfDayMode, 1 /*Integer*/, $DeviceId, 300, 'IPSShadowing_StartOfDay',  $ScriptIdChangeSettings, 0,       'Gear');
   	$ControlIdBeginOfDayTime   = CreateVariable(c_Control_BeginOfDayTime, 3 /*String*/,  $DeviceId, 310, '~String',                  $ScriptIdChangeSettings, '07:00', 'Clock');
		$ControlIdEndOfDayMode     = CreateVariable(c_Control_EndOfDayMode,   1 /*Integer*/, $DeviceId, 300, 'IPSShadowing_EndOfDay',    $ScriptIdChangeSettings, 0,       'Gear');
	   $ControlIdEndOfDayTime     = CreateVariable(c_Control_EndOfDayTime,   3 /*String*/,  $DeviceId, 320, '~String',                  $ScriptIdChangeSettings, '17:00', 'Clock');
		$ControlIdTempProfile      = CreateVariable(c_Control_TempProfile,    1 /*Integer*/, $DeviceId, 330, 'IPSShadowing_TempProfile', $ScriptIdChangeSettings, 0,       'Temperature');

		if ($ShadowingType==c_ShadowingType_Shutter) {
			$ControlIdMovement         = CreateVariable(c_Control_Movement,       1 /*Integer*/, $DeviceId,  10, 'IPSShadowing_MovementSht', $ScriptIdChangeSettings, c_MovementId_Stop,  'Shutter');
			$ControlIdProgramNight     = CreateVariable(c_Control_ProgramNight,   1 /*Integer*/, $DeviceId, 200, 'IPSShadowing_ProgNigSht',  $ScriptIdChangeSettings, c_ProgramId_Manual, 'Bed');
			$ControlIdProgramDay       = CreateVariable(c_Control_ProgramDay,     1 /*Integer*/, $DeviceId, 210, 'IPSShadowing_ProgDaySht',  $ScriptIdChangeSettings, c_ProgramId_Manual, 'Sun');
			$ControlIdProgramTemp      = CreateVariable(c_Control_ProgramTemp,    1 /*Integer*/, $DeviceId, 220, 'IPSShadowing_ProgTempSht', $ScriptIdChangeSettings, c_ProgramId_Manual, 'Temperature');
			$ControlIdProgramPresent   = CreateVariable(c_Control_ProgramPresent, 1 /*Integer*/, $DeviceId, 230, 'IPSShadowing_ProgPreSht',  $ScriptIdChangeSettings, c_ProgramId_Manual, 'Motion');
		} else {
			$ControlIdMovement         = CreateVariable(c_Control_Movement,       1 /*Integer*/, $DeviceId,  10, 'IPSShadowing_MovementJal', $ScriptIdChangeSettings, c_MovementId_Stop,  'Shutter');
			$ControlIdProgramNight     = CreateVariable(c_Control_ProgramNight,   1 /*Integer*/, $DeviceId, 200, 'IPSShadowing_ProgNigJal',  $ScriptIdChangeSettings, c_ProgramId_Manual, 'Bed');
			$ControlIdProgramDay       = CreateVariable(c_Control_ProgramDay,     1 /*Integer*/, $DeviceId, 210, 'IPSShadowing_ProgDayJal',  $ScriptIdChangeSettings, c_ProgramId_Manual, 'Sun');
			$ControlIdProgramTemp      = CreateVariable(c_Control_ProgramTemp,    1 /*Integer*/, $DeviceId, 220, 'IPSShadowing_ProgTempJal', $ScriptIdChangeSettings, c_ProgramId_Manual, 'Temperature');
			$ControlIdProgramPresent   = CreateVariable(c_Control_ProgramPresent, 1 /*Integer*/, $DeviceId, 230, 'IPSShadowing_ProgPreJal',  $ScriptIdChangeSettings, c_ProgramId_Manual, 'Motion');
		}
		if ($DeviceData[c_Property_DevicePath]!='') {
			$DeviceType = $DeviceData[c_Property_DeviceType];
			$DevicePath = $DeviceData[c_Property_DevicePath];

			if ($DeviceType==c_DeviceType_Auto) {
			   $DeviceType = get_DeviceTypeByInstanceId(get_ObjectIDByPath($DevicePath));
			}

			switch($DeviceType) {
			   case c_DeviceType_Homematic:
					$HomematicId  = get_ObjectIDByPath($DevicePath.".LEVEL");
					$EventId      = CreateEvent($DeviceName, $HomematicId, $ScriptIdChangeSettings);
			      break;
			   case c_DeviceType_MoellerEaton:
			   case c_DeviceType_LCN:
			   case c_DeviceType_Enocean:
			   case c_DeviceType_FS20:
			   case c_DeviceType_1Wire:
			   case c_DeviceType_Custom:
					break;
			   case c_DeviceType_ShutterModule:
					$InstanceId  = get_ObjectIDByPath($DevicePath.".Position");
					$EventId      = CreateEvent($DeviceName, $InstanceId, $ScriptIdChangeSettings);
			      break;
				default:
					die("Found Unknown DeviceType '$DeviceType'");
			}
		}

		$Idx = $Idx  + 10;
	}

	$CategoryIdSettings	= CreateCategory('Settings', $CategoryIdShadowing, 30);
	$ControlIdMsgPrioTemp         = CreateVariable(c_Control_MsgPrioTemp,      1 /*Integer*/, $CategoryIdSettings,  60, 'IPSShadowing_Priority',    $ScriptIdChangeSettings, 2);
	$ControlIdMsgPrioProg         = CreateVariable(c_Control_MsgPrioProg,      1 /*Integer*/, $CategoryIdSettings,  70, 'IPSShadowing_Priority',    $ScriptIdChangeSettings, 4);

	// Logging
	$CategoryIdLog	 = CreateCategory('Log', $CategoryIdShadowing, 40);
	$ControlIdLog   = CreateVariable('LogMessages',  3 /*String*/,  $CategoryIdLog, 10, '~HTMLBox', "");
	$ControlIdLogId = CreateVariable('LogId',        1 /*Integer*/, $CategoryIdLog, 20, '', 0);

	SetVariableConstant ('c_ID_LogMessages',           $ControlIdLog,            'IPSShadowing_Constants.ips.php');
	SetVariableConstant ('c_ID_LogId',                 $ControlIdLogId,          'IPSShadowing_Constants.ips.php');
	SetVariableConstant ('c_ID_Devices',               $CategoryIdDevices,       'IPSShadowing_Constants.ips.php');
	SetVariableConstant ('c_ID_Settings',              $CategoryIdSettings,      'IPSShadowing_Constants.ips.php');
	SetVariableConstant ('c_ID_Shadowing',             $CategoryIdShadowing,     'IPSShadowing_Constants.ips.php');
	SetVariableConstant ('c_ID_RefreshTimerScript',    $ScriptIdRefreshTimer,    'IPSShadowing_Constants.ips.php');
	SetVariableConstant ('c_ID_ProgramTimerScript',    $ScriptIdProgramTimer,    'IPSShadowing_Constants.ips.php');
	SetVariableConstant ('c_ID_ResetTimerScript',      $ScriptIdResetTimer,      'IPSShadowing_Constants.ips.php');
	SetVariableConstant ('c_ID_ChangeSettingsScript',  $ScriptIdChangeSettings,  'IPSShadowing_Constants.ips.php');

	// ----------------------------------------------------------------------------------------------------------------------------
	// Webfront Definition
	// ----------------------------------------------------------------------------------------------------------------------------
	$WebFrontId                = CreateCategoryPath($WebfrontPath);
	$WebFrontOverviewId        = CreateCategory('Overview',  $WebFrontId,    10);
	$WebFrontOverviewTop1      = CreateCategory(  'Top1',    $WebFrontOverviewId,    10);
	$WebFrontOverviewTop2      = CreateCategory(  'Top2',    $WebFrontOverviewId,    20);
	$WebFrontOverviewBottom1   = CreateCategory(  'Bottom1', $WebFrontOverviewId,    30);
	$WebFrontOverviewBottom2   = CreateCategory(  'Bottom2', $WebFrontOverviewId,    40);

	CreateWFCItemTabPane   ($WebFrontConfigId, 'ShadowTP',          'roottp',            $WebFrontTabPaneOrderId, $WebFrontTabPaneName, 'Shutter');

	CreateWFCItemSplitPane ($WebFrontConfigId, 'ShadowTP_OV',       'ShadowTP',          10, 'bersicht', 'Shutter', 0 /*Horizontal*/, 260 /*Height*/, 1 /*Target=Pane2*/, 1/*UsePixel*/, 'true');
	CreateWFCItemSplitPane ($WebFrontConfigId, 'ShadowTP_OVTop',    'ShadowTP_OV',       10, '', '', 1 /*Vertical*/, 310 /*Width*/, 1 /*Target=Pane2*/, 1/*UsePixel*/, 'true');
	CreateWFCItemSplitPane ($WebFrontConfigId, 'ShadowTP_OVBottom', 'ShadowTP_OV',       20, '', '', 1 /*Vertical*/, 430 /*Width*/, 1 /*Target=Pane2*/, 1/*UsePixel*/, 'true');
	CreateWFCItemCategory  ($WebFrontConfigId, 'ShadowTP_OVTop1',   'ShadowTP_OVTop',    10, 'Top1', '', $WebFrontOverviewTop1 /*BaseId*/, 'false' /*BarBottomVisible*/);
	CreateWFCItemCategory  ($WebFrontConfigId, 'ShadowTP_OVTop2',   'ShadowTP_OVTop',    20, 'Top2', '', $WebFrontOverviewTop2 /*BaseId*/, 'false' /*BarBottomVisible*/);
	CreateWFCItemCategory  ($WebFrontConfigId, 'ShadowTP_OVBottom1','ShadowTP_OVBottom', 10, 'Bottom1', '', $WebFrontOverviewBottom1 /*BaseId*/, 'false' /*BarBottomVisible*/);
	CreateWFCItemCategory  ($WebFrontConfigId, 'ShadowTP_OVBottom2','ShadowTP_OVBottom', 20, 'Bottom2', '', $WebFrontOverviewBottom2 /*BaseId*/, 'false' /*BarBottomVisible*/);

	// Webfront Overview
	$Idx = 10;
	foreach ($DeviceConfig as $DeviceName=>$DeviceData) {
		$DeviceId  = get_DeviceId($DeviceName, $CategoryIdDevices);

	   // Overview Data
		CreateLink($DeviceName,           get_ControlId(c_Control_Movement, $DeviceId), $WebFrontOverviewTop1, $Idx);
		CreateLinkByDestination('Status', get_ControlId(c_Control_Display,  $DeviceId), $WebFrontOverviewTop2, $Idx);

		// Detailed CircleData
		$WebFrontDetailId             = CreateCategory($DeviceName,         $WebFrontId, 100+$Idx);
		$WebFrontDetailTopId          = CreateCategory("Top",         $WebFrontDetailId, 100+$Idx);
		$WebFrontDetailBottomLeftId   = CreateCategory("BottomLeft",  $WebFrontDetailId, 100+$Idx);
		$WebFrontDetailBottomRightId  = CreateCategory("BottomRight", $WebFrontDetailId, 100+$Idx);
		CreateWFCItemSplitPane ($WebFrontConfigId, "ShadowTP_$DeviceName",              'ShadowTP',             100+$Idx, $DeviceName, '', 0 /*Horizontal*/, 270 /*Hight*/, 0 /*Target=Pane1*/, 1/*UsePixel*/, 'true');
		CreateWFCItemCategory  ($WebFrontConfigId, "ShadowTP_$DeviceName"."Top",        "ShadowTP_$DeviceName", 10, '', '', $WebFrontDetailTopId /*BaseId*/, 'false' /*BarBottomVisible*/);
		CreateWFCItemSplitPane ($WebFrontConfigId, "ShadowTP_$DeviceName"."Bottom",     "ShadowTP_$DeviceName", 20, '', '', 1 /*Vertical*/, 65 /*Width*/, 0 /*Target=Pane1*/, 0/*UsePercentage*/, 'true');
		CreateWFCItemCategory  ($WebFrontConfigId, "ShadowTP_$DeviceName"."BottomLeft", "ShadowTP_$DeviceName"."Bottom", 10, '', '', $WebFrontDetailBottomLeftId  /*BaseId*/, 'false' /*BarBottomVisible*/);
		CreateWFCItemCategory  ($WebFrontConfigId, "ShadowTP_$DeviceName"."BottomRight","ShadowTP_$DeviceName"."Bottom", 10, '', '', $WebFrontDetailBottomRightId /*BaseId*/, 'false' /*BarBottomVisible*/);


		CreateLink('Steuerung',           get_ControlId(c_Control_Movement,        $DeviceId),  $WebFrontDetailTopId, 10);
		$ProgramDeviceId = CreateDummyInstance("Programme", $WebFrontDetailTopId, 20);
		CreateLink('Programm Nacht',      get_ControlId(c_Control_ProgramNight,    $DeviceId),  $ProgramDeviceId, 10);
		CreateLink('Programm Tag',        get_ControlId(c_Control_ProgramDay,      $DeviceId),  $ProgramDeviceId, 20);
		CreateLink('Programm Temperatur', get_ControlId(c_Control_ProgramTemp,     $DeviceId),  $ProgramDeviceId, 30);
		CreateLink('Programm Anwesenend', get_ControlId(c_Control_ProgramPresent,  $DeviceId),  $ProgramDeviceId, 40);

		CreateLink('Temperatur Profil',   get_ControlId(c_Control_TempProfile,     $DeviceId),  $WebFrontDetailBottomLeftId, 5);
		$BeginOfDayDeviceId = CreateDummyInstance("Tages Beginn", $WebFrontDetailBottomLeftId, 10);
		CreateLink('Modus',  get_ControlId(c_Control_BeginOfDayMode,  $DeviceId),  $BeginOfDayDeviceId, 10);
		CreateLink('Zeit',   get_ControlId(c_Control_BeginOfDayTime,  $DeviceId),  $BeginOfDayDeviceId, 20);
		$EndOfDayDeviceId = CreateDummyInstance("Tages Ende", $WebFrontDetailBottomLeftId, 20);
		CreateLink('Modus',    get_ControlId(c_Control_EndOfDayMode,    $DeviceId),  $EndOfDayDeviceId, 30);
		CreateLink('Zeit',     get_ControlId(c_Control_EndOfDayTime,    $DeviceId),  $EndOfDayDeviceId, 40);

		CreateLink('Automatik',           get_ControlId(c_Control_Automatic,       $DeviceId),  $WebFrontDetailBottomRightId, 10);
		CreateLink('Manueller Modus',     get_ControlId(c_Control_ManualChange,    $DeviceId),  $WebFrontDetailBottomRightId, 20);
		CreateLink('Temperatur Modus',    get_ControlId(c_Control_TempChange,      $DeviceId),  $WebFrontDetailBottomRightId, 25);
		CreateLink('Status',              get_ControlId(c_Control_Display,         $DeviceId),  $WebFrontDetailBottomRightId, 30);
		CreateLink('Position',            get_ControlId(c_Control_Position,        $DeviceId),  $WebFrontDetailBottomRightId, 40);

		$Idx = $Idx + 10;
	}

	// Common Settings
	$WebFrontSettingId          = CreateCategory('Settings',         $WebFrontId, 1000);
	CreateWFCItemCategory  ($WebFrontConfigId, 'ShadowTP_Settings', 'ShadowTP', 1000, 'Einstellungen', '', $WebFrontSettingId /*BaseId*/, 'true' /*BarBottomVisible*/);
	CreateLink('Msg Prio. Temparatur',   get_ControlId(c_Control_MsgPrioTemp,     $CategoryIdSettings),  $WebFrontSettingId, 60);
	CreateLink('Msg Prio. Programm',     get_ControlId(c_Control_MsgPrioProg,     $CategoryIdSettings),  $WebFrontSettingId, 70);

	// Overview Bottom
	CreateLink('Meldungen', $ControlIdLog,  $WebFrontOverviewBottom1, 200);

	CreateLink('Automatic Ein',   $ScriptIdAutomaticOn,    $WebFrontOverviewBottom2, 10);
	CreateLink('Automatic Aus',   $ScriptIdAutomaticOff,   $WebFrontOverviewBottom2, 20);
	CreateLink('Automatic Reset', $ScriptIdAutomaticReset, $WebFrontOverviewBottom2, 30);
	CreateLink('Alle Schliessen', $ScriptIdCloseAll,       $WebFrontOverviewBottom2, 100);
	CreateLink('Alle ffnen',     $ScriptIdOpenAll,        $WebFrontOverviewBottom2, 110);


	// ----------------------------------------------------------------------------------------------------------------------------
	// iPhone Definition
	// ----------------------------------------------------------------------------------------------------------------------------
	$iPhoneOverviewId  = CreateCategoryPath($iPhonePath, 30, 'Shutter');
	$Idx               = 10;
	foreach ($DeviceConfig as $DeviceName=>$DeviceData) {
		$DeviceId  = get_DeviceId($DeviceName, $CategoryIdDevices);

	   // iPhone Overview
		CreateLink($DeviceName,    get_ControlId(c_Control_Movement,    $DeviceId), $iPhoneOverviewId, $Idx+200);

		// Detailed CirclyData
		$iPhoneDetailId  = CreateCategory($DeviceName, $iPhoneOverviewId, $Idx);
		CreateLink('Bewegung',            get_ControlId(c_Control_Movement,        $DeviceId),  $iPhoneDetailId, 10);
		CreateLink('Status',              get_ControlId(c_Control_Display,         $DeviceId),  $iPhoneDetailId, 20);
		CreateLink('Position',            get_ControlId(c_Control_Position,        $DeviceId),  $iPhoneDetailId, 30);
		$ProgramDeviceId = CreateDummyInstance("Programme", $iPhoneDetailId, 50);
		CreateLink('Automatik',  get_ControlId(c_Control_Automatic,       $DeviceId),  $ProgramDeviceId, 10);
		CreateLink('Nacht',      get_ControlId(c_Control_ProgramNight,    $DeviceId),  $ProgramDeviceId, 10);
		CreateLink('Tag',        get_ControlId(c_Control_ProgramDay,      $DeviceId),  $ProgramDeviceId, 20);
		CreateLink('Temperatur', get_ControlId(c_Control_ProgramTemp,     $DeviceId),  $ProgramDeviceId, 30);
		CreateLink('Anwesenend', get_ControlId(c_Control_ProgramPresent,  $DeviceId),  $ProgramDeviceId, 40);

		$BeginOfDayDeviceId = CreateDummyInstance("Tages Beginn", $iPhoneDetailId, 100);
		CreateLink('Modus',  get_ControlId(c_Control_BeginOfDayMode,  $DeviceId),  $BeginOfDayDeviceId, 10);
		CreateLink('Zeit',   get_ControlId(c_Control_BeginOfDayTime,  $DeviceId),  $BeginOfDayDeviceId, 20);
		$EndOfDayDeviceId = CreateDummyInstance("Tages Ende", $iPhoneDetailId, 110);
		CreateLink('Modus',    get_ControlId(c_Control_EndOfDayMode,    $DeviceId),  $EndOfDayDeviceId, 10);
		CreateLink('Zeit',     get_ControlId(c_Control_EndOfDayTime,    $DeviceId),  $EndOfDayDeviceId, 20);

		$DeviceSettingsId = CreateDummyInstance("Einstellungen", $iPhoneDetailId, 200);
		CreateLink('Temperatur Profil',   get_ControlId(c_Control_TempProfile,     $DeviceId),  $DeviceSettingsId, 10);
		CreateLink('Manueller Modus',     get_ControlId(c_Control_ManualChange,    $DeviceId),  $DeviceSettingsId, 20);
		CreateLink('Temperatur Modus',    get_ControlId(c_Control_TempChange,      $DeviceId),  $DeviceSettingsId, 30);

		$Idx = $Idx + 10;
	}

	$iPhoneSettingId  = CreateCategory('Einstellungen', $iPhoneOverviewId, 0);
	CreateLink('Msg Prio. Temparatur', get_ControlId(c_Control_MsgPrioTemp,       $CategoryIdSettings),  $iPhoneSettingId, 10);
	CreateLink('Msg Prio. Programm',   get_ControlId(c_Control_MsgPrioProg,       $CategoryIdSettings),  $iPhoneSettingId, 20);
	CreateLink('Meldungen', $ControlIdLog,  $CategoryIdSettings, 100);
	CreateLink('Automatic Ein',   $ScriptIdAutomaticOn,    $CategoryIdSettings, 110);
	CreateLink('Automatic Aus',   $ScriptIdAutomaticOff,   $CategoryIdSettings, 120);
	CreateLink('Automatic Reset', $ScriptIdAutomaticReset, $CategoryIdSettings, 130);
	CreateLink('Alle Schliessen', $ScriptIdCloseAll,       $CategoryIdSettings, 200);
	CreateLink('Alle ffnen',     $ScriptIdOpenAll,        $CategoryIdSettings, 210);

   // ------------------------------------------------------------------------------------------------
	function get_DeviceId($DeviceName, $ParentId) {
	   $CategoryId = IPS_GetCategoryIDByName($DeviceName, $ParentId);
		return $CategoryId;
	}

   // ------------------------------------------------------------------------------------------------
	function get_ControlId($ControlName, $DeviceId) {
	   $VariableId = IPS_GetVariableIDByName($ControlName, $DeviceId);
	   return $VariableId;
	}


?>