<?
	include_once "IPSLogger.ips.php";
	include_once "IPSShadowing_Configuration.ips.php";

	// ----------------------------------------------------------------------------------------------------------------------------
	function get_MessageOpenDimout($DeviceId) {
		$ToBeMoved = GetValue(get_ControlId(c_Control_Movement, $DeviceId));

		if ($ToBeMoved==c_MovementId_Opened) {
			$Message = "ffnen";
		} elseif ($ToBeMoved==c_MovementId_Dimout) {
			$Message = "Abdunkelung";
		} elseif ($ToBeMoved==c_MovementId_Closed) {
			$Message = "Geschlossen";
		} elseif ($ToBeMoved==c_MovementId_Shadowing) {
			$Message = "Beschattung";
		} elseif ($ToBeMoved==c_MovementId_Up) {
			$Message = "Manuelles ffnen";
		} elseif ($ToBeMoved==c_MovementId_Down) {
			$Message = "Manuelles Schliessen";
		} else {
			$Message = "Stop";
		}
		return $Message;
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function IPSShadowing_LogMoveByControl($DeviceId) {
		$DeviceName = get_DeviceNameByDeviceId($DeviceId);
		$Message    = get_MessageOpenDimout($DeviceId)." von '$DeviceName' (Manuell)";
		IPSLogger_Inf(__file__, $Message);
		IPSShadowing_Log($Message);
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function IPSShadowing_LogMoveByProgram($DeviceId, $ProgramId, $TriggeredByTemp) {
		$Message     = get_MessageOpenDimout($DeviceId);
      $DeviceName  = get_DeviceNameByDeviceId($DeviceId);
      $ProgramName = get_ProgramName($ProgramId);

		if ($TriggeredByTemp) {
			$Priority = GetValue(get_SettingControlId(c_Control_MsgPrioTemp, $DeviceId));
			$Message .= " von '$DeviceName' ('$ProgramName' Temperatur gesteuert)";
		} else {
			$Priority = GetValue(get_SettingControlId(c_Control_MsgPrioProg, $DeviceId));
			$Message .= " von '$DeviceName' ('$ProgramName' Zeit gesteuert)";
		}

		IPSShadowing_Log($Message);
		IPSLogger_Not(__file__, $Message, $Priority);
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function IPSShadowing_LogChange($DeviceId, $Value, $ControlId) {
		$DeviceName  = IPS_GetName($DeviceId);
		$ControlType = get_ControlType($ControlId);
		if ($Value===true) {
		   $Value = 'Ein';
		} elseif ($Value===false) {
		   $Value = 'Aus';
		} else {
		}
		IPSLogger_Inf(__file__,"Configuration Change for Device '$DeviceName': $ControlType=$Value");
		IPSShadowing_Log("nderung von '$ControlType' auf $Value fr '$DeviceName'");
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function IPSShadowing_Log($Msg) {
		IPSLogger_OutProgram($Msg, c_ID_LogMessages, c_ID_LogId, c_LogMessage_Count);
	}

?>