<?
	include_once "IPSLogger.ips.php";
	include_once "IPSShadowing_Movement.ips.php";
	
	// ----------------------------------------------------------------------------------------------------------------------------
	function get_BeginOfDay($DeviceId) {
	   $Time = GetValue(get_ControlId(c_Control_BeginOfDayTime, $DeviceId));
		$Date = mktime(substr($Time,0,2), substr($Time,3,2), 0);

		return $Date;
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function get_EndOfDay($DeviceId) {
	   $Time = GetValue(get_ControlId(c_Control_EndOfDayTime, $DeviceId));
		$Date = mktime(substr($Time,0,2), substr($Time,3,2), 0);

		return $Date;
	}


	// ----------------------------------------------------------------------------------------------------------------------------
	function get_ActivationByTemp($Delta, $DeviceId) {
	   $ControlId = get_ControlId(c_Control_TempProfile, $DeviceId);
	   if ($ControlId===false) {
	      return false;
		}

		$TempOutdoorControlId = get_IdByPath(c_Setting_TempOutdoorPath);
		$TempIndoorControlId  = get_IdByPath(c_Setting_TempIndoorPath);
	   if (($TempOutdoorControlId===false) or ($TempIndoorControlId===false)) {
	      return false;
		}

		//Example:
		// Aussen >= Innen+2
		//Outdoor=16,Indoor=22,  -->  -6 >= 2 -> false
		//Outdoor=20,Indoor=22,  -->  -2 >= 2 -> false
		//Outdoor=26,Indoor=22,  -->   4 >= 2 -> true
		return (GetValue($TempOutdoorControlId)-GetValue($TempIndoorControlId)) >= (GetValue($ControlId)+$Delta);
	}

	// ----------------------------------------------------------------------------------------------------------------------------
	function get_ConfigValueByPath($Path) {
	   $ControlId = get_IdByPath($Path);
	   if ($ControlId===false) {
	      return false;
		}
		return GetValue($ControlId);
	}


   //SetValue(get_IdByPath(c_Setting_TempIndoorPath),  24);
   //SetValue(get_IdByPath(c_Setting_TempOutdoorPath), 22);
   //IPSShadowing_Program();

	// ----------------------------------------------------------------------------------------------------------------------------
	function IPSShadowing_Program() {
	   $Present        = get_ConfigValueByPath(c_Setting_PresentPath);

	   $DeviceIds = IPS_GetChildrenIds(c_ID_Devices);
		foreach($DeviceIds as $DeviceId) {
			//$DeviceId=27094; //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		   $ShadowByTemp   = get_ActivationByTemp(0, $DeviceId);
		   $DimoutByTemp   = get_ActivationByTemp(2, $DeviceId);
		   $CloseByTemp    = get_ActivationByTemp(0, $DeviceId);
		   $OpenByTemp     = get_ActivationByTemp(-1, $DeviceId);
		   $isDay          = ((time() >= get_BeginOfDay($DeviceId)) and (time() <= get_EndOfDay($DeviceId)));
		   $Position       = GetValue(get_ControlId(c_Control_Position, $DeviceId));
		   $ProgramPresent = GetValue(get_ControlId(c_Control_ProgramPresent, $DeviceId));
		   $ProgramTemp    = GetValue(get_ControlId(c_Control_ProgramTemp, $DeviceId));
		   $TempChange     = GetValue(get_ControlId(c_Control_TempChange, $DeviceId));

			echo "Process ".IPS_GetName($DeviceId)."... \n";

			// Manual Change ...
		   if (GetValue(get_ControlId(c_Control_ManualChange, $DeviceId))) {
				echo "ManualChange ... \n";

			// Automatic Off ...
		   } elseif (!GetValue(get_ControlId(c_Control_Automatic, $DeviceId))) {
				echo "Automatic Off ... \n";

			// Present ...
		   } elseif ($Present and $ProgramPresent<>c_ProgramId_Manual) {
				echo "ProgramByPresent \n";
				IPSShadowing_MoveByProgram($DeviceId, $ProgramPresent);

			// Custom
		   } elseif (IPSShadowing_ProgramCustom($DeviceId, $isDay)) {
				// Action done in Custom Procedure

			// Temperature
		   } elseif ($isDay and $CloseByTemp and $ProgramTemp<>c_ProgramId_Manual) {

		   	if ($CloseByTemp and ($ProgramTemp==c_ProgramId_Closed or $ProgramTemp==c_ProgramId_Dimout)) {
					echo "ProgramByTemperature (Close) \n";
					IPSShadowing_MoveByProgram($DeviceId, $ProgramTemp, true/*DimoutOption*/, true/*TriggeredByTemp*/);

				} elseif ($DimoutByTemp) {
					echo "ProgramByTemperature (Dimout) \n";
					IPSShadowing_MoveByProgram($DeviceId, $ProgramTemp, true/*DimoutOption*/, true/*TriggeredByTemp*/);

				} elseif ($TempChange) {
				   echo "ProgramByTemperature (ShadowingDoNothing) \n";

				} elseif ($ShadowByTemp) {
				   echo "ProgramByTemperature (Shadowing) \n";
				   IPSShadowing_MoveByProgram($DeviceId, $ProgramTemp, false/*DimoutOption*/, true/*TriggeredByTemp*/);
				} else {
				   echo "ProgramByTemperature (Else) \n";
				}

			// Day
		   } elseif ($isDay) {
				if (!$OpenByTemp and $TempChange) {
					echo "ProgramByDay (TemperaturReset) \n";
					SetValue(get_ControlId(c_Control_TempChange, $DeviceId), false);
					IPSShadowing_MoveByProgram($DeviceId, GetValue(get_ControlId(c_Control_ProgramDay, $DeviceId)));
				} elseif ($OpenByTemp and $TempChange) {
					echo "ProgramByDay (TemperaturDoNothing) \n";
					IPSShadowing_MoveByProgram($DeviceId, GetValue(get_ControlId(c_Control_ProgramDay, $DeviceId)));
				} else {
					echo "ProgramByDay \n";
					IPSShadowing_MoveByProgram($DeviceId, GetValue(get_ControlId(c_Control_ProgramDay, $DeviceId)));
				}
				
			// Night
		   } else {
				echo "ProgramByNight=".GetValue(get_ControlId(c_Control_ProgramNight, $DeviceId))." ... \n";
				IPSShadowing_MoveByProgram($DeviceId, GetValue(get_ControlId(c_Control_ProgramNight, $DeviceId)));
		   }
		   //return;//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		}
	}
		   
?>